#include-once

#include <IE.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <..\includes\HotKey.au3> ; http://www.autoitscript.com/forum/index.php?showtopic=90492
#include <..\includes\vkConstants.au3> ; http://www.autoitscript.com/forum/index.php?showtopic=90492
#include <..\includes\Processus.au3>

Opt("WinTitleMatchMode", 4)

Global Const $FENETRE_MEDIADICO = "[TITLE:MEDIADICO pour votre PC; CLASS:#32770]"
Global Const $REP_MEDIADICO = "C:\Program Files\LAventure\MEDIADICO pour votre PC\"
Global Const $EXE_MEDIADICO = "C:\Program Files\LAventure\MEDIADICO pour votre PC\MDVPC.exe"

Global $oIE_MediaDico
Global $hIE_MediaDico, $hMediaDico, $pidMediaDico

Func MediaDico_AssigneRaccClavier()
	_HotKeyAssign($VK_F1, 'MediaDico_Aide', $hMediaDico)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_RETURN), 'MediaDico_PositionneSurContenu', $hMediaDico)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_O), 'MediaDico_DescendsPage', $hMediaDico, 0, 50, 50)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_P), 'MediaDico_MontePage', $hMediaDico, 0, 50, 50)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_J), 'MediaDico_Descends', $hMediaDico, 0, 50, 25)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_K), 'MediaDico_Monte', $hMediaDico, 0, 50, 250)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_N), 'MediaDico_NouvelleRecherche', $hMediaDico)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_R), 'MediaDico_AppuieToucheEntree', $hMediaDico)
	_HotKeyAssign(BitOR($CK_CONTROL, $VK_W), 'MediaDico_CacheDico', $hMediaDico)
EndFunc   ;==>MediaDico_AssigneRaccClavier

Func MediaDico_OuvreDico()
	Local $etatFenetre = WinGetState($FENETRE_MEDIADICO)

	If Not WinExists($FENETRE_MEDIADICO) Then ; si la fentre n'existe pas
		MediaDico_DemarreDico()
		MediaDico_AfficheDico()
	Else
		If Not $pidMediaDico Then $pidMediaDico = WinGetProcess($FENETRE_MEDIADICO)

		If $etatFenetre = 15 Then ; si la fentre est visible, active, ...
			MediaDico_CacheDico()
		Else
			MediaDico_AfficheDico()
		EndIf
	EndIf
EndFunc   ;==>MediaDico_OuvreDico

Func MediaDico_AttacheDico()
	WinWait($FENETRE_MEDIADICO)

	If Not $pidMediaDico Then $pidMediaDico = WinGetProcess($FENETRE_MEDIADICO)
	_ReprendProcessus($pidMediaDico)

	$hMediaDico = WinGetHandle($FENETRE_MEDIADICO)

	Do
		$oIE_MediaDico = _IEAttach($FENETRE_MEDIADICO, "Embedded")

		Sleep(500)
	Until IsObj($oIE_MediaDico)
	_IELoadWait($oIE_MediaDico)

	MediaDico_AssigneRaccClavier()
EndFunc   ;==>MediaDico_AttacheDico

Func MediaDico_DemarreDico()
	$pidMediaDico = Run($EXE_MEDIADICO, $REP_MEDIADICO, @SW_MINIMIZE)

	MediaDico_AttacheDico()
EndFunc   ;==>MediaDico_DemarreDico

Func MediaDico_Aide()
	MsgBox(64, "Aide", _
			"Aide : F1" & @CRLF & _
			"Se positionne sur contenu :" & " Entre" & @CRLF & _
			"Descends d'une page :" & " CTRL + O" & @CRLF & _
			"Monte d'une page :" & " CTRL + P" & @CRLF & _
			"Descends :" & " CTRL + J" & @CRLF & _
			"Monte :" & " CTRL + K" & @CRLF & _
			"Nouvelle recherche :" & " CTRL + N" & @CRLF & _
			"Appuie sur la touche 'Entre' :" & " CTRL + R" & @CRLF & _
			"Cacher le dictionnaire :" & " CTRL + W")
EndFunc   ;==>MediaDico_Aide

Func MediaDico_AfficheDico()
	_ReprendProcessus($pidMediaDico)

	WinSetState($FENETRE_MEDIADICO, "", @SW_SHOWNORMAL)
	WinActivate($FENETRE_MEDIADICO)

	MediaDico_NouvelleRecherche()
EndFunc   ;==>MediaDico_AfficheDico

Func MediaDico_CacheDico()
	WinSetState($FENETRE_MEDIADICO, "", @SW_HIDE)

	_SuspendProcessus($pidMediaDico)
	_ReduitMemoire($pidMediaDico)
EndFunc   ;==>MediaDico_CacheDico

Func MediaDico_NouvelleRecherche()
	ControlClick($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "primary", 2, 400, 30)
EndFunc   ;==>MediaDico_NouvelleRecherche

Func MediaDico_AppuieToucheEntree()
	Send("{ENTER}")
EndFunc   ;==>MediaDico_AppuieToucheEntree

Func MediaDico_PositionneSurContenu()
	ControlClick($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "secondary", 1, 656, 150)
EndFunc   ;==>MediaDico_PositionneSurContenu

Func MediaDico_Descends()
	MediaDico_PositionneSurContenu()
	ControlSend($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "{DOWN 4}")
EndFunc   ;==>MediaDico_Descends

Func MediaDico_Monte()
	MediaDico_PositionneSurContenu()
	ControlSend($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "{UP 4}")
EndFunc   ;==>MediaDico_Monte

Func MediaDico_DescendsPage()
	MediaDico_PositionneSurContenu()
	ControlSend($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "{PGDN}")
EndFunc   ;==>MediaDico_DescendsPage

Func MediaDico_MontePage()
	MediaDico_PositionneSurContenu()
	ControlSend($FENETRE_MEDIADICO, "", "Internet Explorer_Server1", "{PGUP}")
EndFunc   ;==>MediaDico_MontePage

Func _Quitte()
	Exit
EndFunc   ;==>_Quitte

Func OnAutoItExit()
	If WinExists($FENETRE_MEDIADICO) Then
		MediaDico_OuvreDico()
	EndIf

	ToolTip("Quitte le script AutoIt...", 0, 0)
	Sleep(2500)
	ToolTip("")
EndFunc   ;==>OnAutoItExit