; MdiaDico
;
; http://www.mediadico.com/mdvpc/mdvpc.asp
;
; _HotKeyAssign($VK_F1, 'MediaDico_Aide', $hMediaDico)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_RETURN), 'MediaDico_PositionneSurContenu', $hMediaDico)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_O), 'MediaDico_DescendsPage', $hMediaDico, 0, 50, 50)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_P), 'MediaDico_MontePage', $hMediaDico, 0, 50, 50)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_J), 'MediaDico_Descends', $hMediaDico, 0, 50, 25)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_K), 'MediaDico_Monte', $hMediaDico, 0, 50, 250)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_N), 'MediaDico_NouvelleRecherche', $hMediaDico)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_R), 'MediaDico_ApppuieToucheEntree, $hMediaDico)
; _HotKeyAssign(BitOR($CK_CONTROL, $VK_W), 'MediaDico_CacheDico', $hMediaDico)

; CNRLT
;
; ["{F1}", $CNRLT_CtrlAide], _
; ["^{ENTER}", $CNRLT_CtrlPositionneSurContenu], _
; ["^o", $CNRLT_CtrlDescendsPage], _
; ["^p", $CNRLT_CtrlMontePage], _
; ["^j", $CNRLT_CtrlDescends], _
; ["^k", $CNRLT_CtrlMonte], _
; ["^n", $CNRLT_CtrlNouvelleRecherche], _
; ["^r", $CNRLT_AppuieToucheEntree], _
; ["^w", $CNRLT_CtrlCacheDico]]

; Google
;
; CTRL + Q pour traduire le texte slectionn
; Bouger la souris pour faire disparatre la traduction
; Maintenir CTRL pour garder la traduction mme en bougeant la souris

#NoTrayIcon

#include <dictionnaires\MdiaDico.au3>
#include <dictionnaires\CNRLT.au3>
#include <traducteurs\Google.au3>

Opt('MustDeclareVars', 1)

Global $msg

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; MdiaDico
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HotKeySet("^!+#d", "_Quitte")

If Not WinExists($FENETRE_MEDIADICO) Then ; si la fentre n'existe pas
	MediaDico_DemarreDico()

	; tente de cacher la fentre jusqu' ce qu'elle n'ait plus l'tat "visible"
	Do
		MediaDico_CacheDico()
		Sleep(500)
	Until BitAND(WinGetState($FENETRE_MEDIADICO), 2) = 0
Else
	MediaDico_AttacheDico()
EndIf

HotKeySet("#x", "MediaDico_OuvreDico")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; CNRLT
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CNRLT_DemarreDico()

HotKeySet("#w", "CNRLT_OuvreDico")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Google
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HotKeySet("#q", "Google_traduit")

; boucle principale
While 1
	$msg = GUIGetMsg()

	; CNRLT.au3 doit tre inclu
	Select
		Case $msg = $CNRLT_CtrlAide
			CNRLT_Aide()

		Case $msg = $CNRLT_CtrlPositionneSurContenu
			CNRLT_PositionneSurContenu()

		Case $msg = $CNRLT_CtrlDescendsPage
			CNRLT_DescendsPage()

		Case $msg = $CNRLT_CtrlMontePage
			CNRLT_MontePage()

		Case $msg = $CNRLT_CtrlDescends
			CNRLT_Descends()

		Case $msg = $CNRLT_CtrlMonte
			CNRLT_Monte()

		Case $msg = $CNRLT_CtrlNouvelleRecherche
			CNRLT_NouvelleRecherche()
			
		Case $msg = $CNRLT_AppuieToucheEntree
			CNRLT_AppuieToucheEntree()

		Case $msg = $CNRLT_CtrlCacheDico
			CNRLT_CacheDico()
	EndSelect

	If $msg = $GUI_EVENT_CLOSE Then CNRLT_CacheDico()
WEnd