#include-once

#include <IE.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
;~ #include <..\includes\HotKey.au3> ; http://www.autoitscript.com/forum/index.php?showtopic=90492
;~ #include <..\includes\vkConstants.au3> ; http://www.autoitscript.com/forum/index.php?showtopic=90492
#include <..\includes\Processus.au3>

Global Const $CNRLT_H = 600
Global Const $CNRLT_L = 915

Global $oIE_CNRLT
Global $hCNRLT = GUICreate("CNRLT", $CNRLT_L - 5, $CNRLT_H)

;~ 	; boutons pour les raccourcis clavier
Global $CNRLT_CtrlAide = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlPositionneSurContenu = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlMontePage = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlDescendsPage = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlMonte = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlDescends = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlNouvelleRecherche = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_CtrlCacheDico = GUICtrlCreateButton("", 0, 0, 0, 0)
Global $CNRLT_AppuieToucheEntree = GUICtrlCreateButton("", 0, 0, 0, 0)

Func CNRLT_AssigneRaccClavier()
	Local $raccClavier[9][2] = [ _
			["{F1}", $CNRLT_CtrlAide], _
			["^{ENTER}", $CNRLT_CtrlPositionneSurContenu], _
			["^o", $CNRLT_CtrlDescendsPage], _
			["^p", $CNRLT_CtrlMontePage], _
			["^j", $CNRLT_CtrlDescends], _
			["^k", $CNRLT_CtrlMonte], _
			["^n", $CNRLT_CtrlNouvelleRecherche], _
			["^r", $CNRLT_AppuieToucheEntree], _
			["^w", $CNRLT_CtrlCacheDico]]

	GUISetAccelerators($raccClavier)

;~ 	_HotKeyAssign($VK_F1, 'CNRLT_Aide', $hCNRLT)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_RETURN), 'CNRLT_PositionneSurContenu', $hCNRLT)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_O), 'CNRLT_DescendsPage', $hCNRLT, 0, 50, 50)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_P), 'CNRLT_MontePage', $hCNRLT, 0, 50, 50)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_J), 'CNRLT_Descends', $hCNRLT, 0, 50, 25)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_K), 'CNRLT_Monte', $hCNRLT, 0, 50, 250)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_N), 'CNRLT_NouvelleRecherche', $hCNRLT)
;~ 	_HotKeyAssign(BitOR($CK_CONTROL, $VK_W), 'CNRLT_CacheDico', $hCNRLT)
EndFunc   ;==>CNRLT_AssigneRaccClavier

Func CNRLT_OuvreDico()
	Local $etatFenetre = WinGetState($hCNRLT)

	If IsObj($oIE_CNRLT) Then
		If $etatFenetre = 15 Then ; si la fentre est visible, active, ...
			CNRLT_CacheDico()
		Else
			CNRLT_AfficheDico()
		EndIf
	EndIf
EndFunc   ;==>CNRLT_OuvreDico

Func CNRLT_DemarreDico()
	$oIE_CNRLT = _IECreateEmbedded()

	Local $GUIActiveX = GUICtrlCreateObj($oIE_CNRLT, -5, 0, $CNRLT_L, $CNRLT_H)

	_IENavigate($oIE_CNRLT, "http://www.cnrtl.fr/definition/", 0)

	CNRLT_AssigneRaccClavier()
EndFunc   ;==>CNRLT_DemarreDico

Func CNRLT_Aide()
	MsgBox(64, "Aide", _
			"Aide : F1" & @CRLF & _
			"Se positionne sur contenu :" & " Entre" & @CRLF & _
			"Descends d'une page :" & " CTRL + O" & @CRLF & _
			"Monte d'une page :" & " CTRL + P" & @CRLF & _
			"Descends :" & " CTRL + J" & @CRLF & _
			"Monte :" & " CTRL + K" & @CRLF & _
			"Nouvelle recherche :" & " CTRL + N" & @CRLF & _
			"Appuie sur la touche 'Entre' :" & " CTRL + R" & @CRLF & _
			"Cacher le dictionnaire :" & " CTRL + W")
EndFunc   ;==>CNRLT_Aide

Func CNRLT_AfficheDico()
	GUISetState(@SW_SHOWNORMAL)
	WinActivate($hCNRLT)

;~ 	CNRLT_NouvelleRecherche()
EndFunc   ;==>CNRLT_AfficheDico

Func CNRLT_AppuieToucheEntree()
	Send("{ENTER}")
EndFunc   ;==>CNRLT_AppuieToucheEntree

Func CNRLT_CacheDico()
	GUISetState(@SW_HIDE)
EndFunc   ;==>CNRLT_CacheDico

Func CNRLT_NouvelleRecherche()
	CNRLT_PositionneSurContenu()
	ControlSend($hCNRLT, "", "Internet Explorer_Server1", "{HOME}")
	ControlClick($hCNRLT, "", "Internet Explorer_Server1", "primary", 2, 320, 160)
EndFunc   ;==>CNRLT_NouvelleRecherche

Func CNRLT_PositionneSurContenu()
	ControlClick($hCNRLT, "", "Internet Explorer_Server1", "primary", 1, 1, 1)
EndFunc   ;==>CNRLT_PositionneSurContenu

Func CNRLT_Descends()
	CNRLT_PositionneSurContenu()
	ControlSend($hCNRLT, "", "Internet Explorer_Server1", "{DOWN 4}")
EndFunc   ;==>CNRLT_Descends

Func CNRLT_Monte()
	CNRLT_PositionneSurContenu()
	ControlSend($hCNRLT, "", "Internet Explorer_Server1", "{UP 4}")
EndFunc   ;==>CNRLT_Monte

Func CNRLT_DescendsPage()
	CNRLT_PositionneSurContenu()
	ControlSend($hCNRLT, "", "Internet Explorer_Server1", "{PGDN}")
EndFunc   ;==>CNRLT_DescendsPage

Func CNRLT_MontePage()
	CNRLT_PositionneSurContenu()
	ControlSend($hCNRLT, "", "Internet Explorer_Server1", "{PGUP}")
EndFunc   ;==>CNRLT_MontePage